// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.27.0
// source: event.sql

package sqlc

import (
	"context"
	"database/sql"
	"encoding/json"
	"time"
)

const getEventByID = `-- name: GetEventByID :one
SELECT
    e.id,
    e.name,
    e.description,
    e.total_amount,
    e.default_currency,
    e.created_at,
    e.updated_at,
    json_build_object(
        'id', o.id,
        'first_name', o.first_name,
        'last_name', o.last_name
    ) AS owner,
    json_agg(
        json_build_object(
            'id', u.id,
            'first_name', u.first_name,
            'last_name', u.last_name
        )
    ) AS users  -- Aggregation for users in the event
FROM "event" e
JOIN "participation" p ON p.event_id = e.id  -- participation linked with the event
JOIN "user" u ON u.id = p.user_id            -- and the query user
JOIN "user" o ON o.id = e.owner_id           -- get the owner info
WHERE e.id = $1
GROUP BY
    e.id, e.name, e.description, e.created_at, e.updated_at,
    e.total_amount, e.default_currency,
    o.id, o.first_name, o.last_name
`

type GetEventByIDRow struct {
	ID              int32
	Name            string
	Description     sql.NullString
	TotalAmount     sql.NullInt32
	DefaultCurrency string
	CreatedAt       time.Time
	UpdatedAt       time.Time
	Owner           json.RawMessage
	Users           json.RawMessage
}

func (q *Queries) GetEventByID(ctx context.Context, id int32) (GetEventByIDRow, error) {
	row := q.db.QueryRowContext(ctx, getEventByID, id)
	var i GetEventByIDRow
	err := row.Scan(
		&i.ID,
		&i.Name,
		&i.Description,
		&i.TotalAmount,
		&i.DefaultCurrency,
		&i.CreatedAt,
		&i.UpdatedAt,
		&i.Owner,
		&i.Users,
	)
	return i, err
}

const insertEvent = `-- name: InsertEvent :one
INSERT INTO "event" (
    name, description, total_amount, default_currency, owner_id, created_at, updated_at
) VALUES ( $1, $2, $3, $4, $5, $6, $7 )
RETURNING id, name, description, default_currency, owner_id, created_at, updated_at, total_amount
`

type InsertEventParams struct {
	Name            string
	Description     sql.NullString
	TotalAmount     sql.NullInt32
	DefaultCurrency string
	OwnerID         int32
	CreatedAt       time.Time
	UpdatedAt       time.Time
}

func (q *Queries) InsertEvent(ctx context.Context, arg InsertEventParams) (Event, error) {
	row := q.db.QueryRowContext(ctx, insertEvent,
		arg.Name,
		arg.Description,
		arg.TotalAmount,
		arg.DefaultCurrency,
		arg.OwnerID,
		arg.CreatedAt,
		arg.UpdatedAt,
	)
	var i Event
	err := row.Scan(
		&i.ID,
		&i.Name,
		&i.Description,
		&i.DefaultCurrency,
		&i.OwnerID,
		&i.CreatedAt,
		&i.UpdatedAt,
		&i.TotalAmount,
	)
	return i, err
}

const listEventsByUserID = `-- name: ListEventsByUserID :many
SELECT
    e.id,
    e.name,
    e.description,
    e.created_at,
    json_build_object(
        'id', o.id,
        'first_name', o.first_name,
        'last_name', o.last_name
    ) AS owner
FROM "event" e
JOIN "participation" p ON p.event_id = e.id  -- participation linked with the event
JOIN "user" o ON o.id = e.owner_id           -- get the owner info
WHERE e.id IN (
    SELECT pt.event_id FROM participation pt WHERE pt.user_id = $1 -- consider the events participated by user_id
)
GROUP BY
    e.id, e.name, e.description, e.created_at,
    o.id, o.first_name, o.last_name
`

type ListEventsByUserIDRow struct {
	ID          int32
	Name        string
	Description sql.NullString
	CreatedAt   time.Time
	Owner       json.RawMessage
}

func (q *Queries) ListEventsByUserID(ctx context.Context, userID int32) ([]ListEventsByUserIDRow, error) {
	rows, err := q.db.QueryContext(ctx, listEventsByUserID, userID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []ListEventsByUserIDRow
	for rows.Next() {
		var i ListEventsByUserIDRow
		if err := rows.Scan(
			&i.ID,
			&i.Name,
			&i.Description,
			&i.CreatedAt,
			&i.Owner,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const updateEventByID = `-- name: UpdateEventByID :exec
UPDATE "event"
SET name = $2, description = $3, updated_at = $4
WHERE id = $1
`

type UpdateEventByIDParams struct {
	ID          int32
	Name        string
	Description sql.NullString
	UpdatedAt   time.Time
}

func (q *Queries) UpdateEventByID(ctx context.Context, arg UpdateEventByIDParams) error {
	_, err := q.db.ExecContext(ctx, updateEventByID,
		arg.ID,
		arg.Name,
		arg.Description,
		arg.UpdatedAt,
	)
	return err
}
